
#include <gtk/gtk.h>
#include "gtkform.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/* Our callback.
 * The data passed to this function is printed to stdout */
void callback( GtkWidget *widget,
               gpointer   data )
{
    g_print ("Hello again - %s was pressed\n", (char *) data);
}

/* This callback quits the program */
gint delete_event( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data )
{
    gtk_main_quit ();
    return FALSE;
}

int main( int   argc,
          char *argv[] )
{
    GtkWidget *window;
    GtkWidget *button1;
    GtkWidget *button2;
    GtkWidget *button3;
    GtkWidget *button4;
    GtkWidget *quit;
    GtkWidget *form;
	int c ;
	guint width = 0 ;
	guint fwidth = 0 ;
	gboolean self = FALSE ;

    gtk_init (&argc, &argv);

	while ( (c=getopt(argc, argv, "b:B:s")) != EOF ) {
		switch (c) {
		case 'b' :
			fwidth = atoi(optarg) ;
			break ;
		case 'B' :
			width = atoi(optarg) ;
			break ;
		case 's' :
			self = TRUE ;
			break ;
		default :
			fprintf(stderr, "usage: form [-b n] [-B n] [-s]\n") ;
			fprintf(stderr, "   -b n    border width of form\n") ;
			fprintf(stderr, "   -B n    border width of window\n") ;
			fprintf(stderr, "   -s      make self attachments\n") ;
			return 1 ;
		}
	}

    /* Create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

    /* Set the window title */
    gtk_window_set_title (GTK_WINDOW (window), "Table");

    /* Set a handler for delete_event that immediately
     * exits GTK. */
    g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK (delete_event), NULL);

    /* Sets the border width of the window. */
    gtk_container_set_border_width (GTK_CONTAINER (window), width);

    /* Create a form */
    form = gtk_form_new ();

    /* Put the form in the main window */
    gtk_container_add (GTK_CONTAINER (window), form);
    gtk_container_set_border_width (GTK_CONTAINER (form), fwidth);

    /* Create first button */
    button1 = gtk_button_new_with_label ("button 1");

    /* When the button is clicked, we call the "callback" function
     * with a pointer to "button 1" as its argument */
    g_signal_connect (G_OBJECT (button1), "clicked",
	              G_CALLBACK (callback), (gpointer) "button 1");


    /* Insert button 1 into the upper left quadrant of the form */
	gtk_container_add(GTK_CONTAINER(form), button1);
    gtk_form_constrain (GTK_FORM (form), button1, GTK_FORM_EDGE_TOP, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), button1, GTK_FORM_EDGE_LEFT, GTK_FORM_ATTACH_FORM, NULL, 0);
	if ( self ) {
	  gtk_form_constrain (GTK_FORM (form), button1, GTK_FORM_EDGE_RIGHT, GTK_FORM_ATTACH_SELF, NULL, 0);
	  gtk_form_constrain (GTK_FORM (form), button1, GTK_FORM_EDGE_BOTTOM, GTK_FORM_ATTACH_SELF, NULL, 0);
	}

    gtk_widget_show (button1);

    /* Create second button */

    button2 = gtk_button_new_with_label ("button 2");

    /* When the button is clicked, we call the "callback" function
     * with a pointer to "button 2" as its argument */
    g_signal_connect (G_OBJECT (button2), "clicked",
                      G_CALLBACK (callback), (gpointer) "button 2");

    /* Insert button 2 into the upper right quadrant of the form */
	gtk_container_add(GTK_CONTAINER(form), button2);
    gtk_form_constrain (GTK_FORM (form), button2, GTK_FORM_EDGE_TOP, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), button2, GTK_FORM_EDGE_LEFT, GTK_FORM_ATTACH_WIDGET, button1, 0);
	if ( self ) {
	  gtk_form_constrain (GTK_FORM (form), button2, GTK_FORM_EDGE_RIGHT, GTK_FORM_ATTACH_SELF, NULL, 0);
	  gtk_form_constrain (GTK_FORM (form), button2, GTK_FORM_EDGE_BOTTOM, GTK_FORM_ATTACH_SELF, NULL, 0);
	}

    gtk_widget_show (button2);

    /* Create third button */

    button3 = gtk_button_new_with_label ("button 3");

    /* When the button is clicked, we call the "callback" function
     * with a pointer to "button 2" as its argument */
    g_signal_connect (G_OBJECT (button3), "clicked",
                      G_CALLBACK (callback), (gpointer) "button 3");

    /* Insert button 3 into the upper right quadrant of the form */
	gtk_container_add(GTK_CONTAINER(form), button3);
    gtk_form_constrain (GTK_FORM (form), button3, GTK_FORM_EDGE_TOP, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), button3, GTK_FORM_EDGE_LEFT, GTK_FORM_ATTACH_WIDGET, button2, 0);
	if ( self ) {
	  gtk_form_constrain (GTK_FORM (form), button3, GTK_FORM_EDGE_RIGHT, GTK_FORM_ATTACH_SELF, NULL, 0);
	  gtk_form_constrain (GTK_FORM (form), button3, GTK_FORM_EDGE_BOTTOM, GTK_FORM_ATTACH_SELF, NULL, 0);
	}

    gtk_widget_show (button3);

    /* Create fourth button */

    button4 = gtk_button_new_with_label ("button 4");

    /* When the button is clicked, we call the "callback" function
     * with a pointer to "button 2" as its argument */
    g_signal_connect (G_OBJECT (button4), "clicked",
                      G_CALLBACK (callback), (gpointer) "button 4");

    /* Insert button 4 into the upper right quadrant of the form */
	gtk_container_add(GTK_CONTAINER(form), button4);
    gtk_form_constrain (GTK_FORM (form), button4, GTK_FORM_EDGE_TOP, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), button4, GTK_FORM_EDGE_LEFT, GTK_FORM_ATTACH_WIDGET, button3, 0);
    gtk_form_constrain (GTK_FORM (form), button4, GTK_FORM_EDGE_RIGHT, GTK_FORM_ATTACH_FORM, NULL, 0);
	if ( self ) {
	  gtk_form_constrain (GTK_FORM (form), button4, GTK_FORM_EDGE_BOTTOM, GTK_FORM_ATTACH_SELF, NULL, 0);
	}

    gtk_widget_show (button4);

    /* Create "Quit" button */
    quit = gtk_button_new_with_label ("Quit");

    /* When the button is clicked, we call the "delete_event" function
     * and the program exits */
    g_signal_connect (G_OBJECT (quit), "clicked",
                      G_CALLBACK (delete_event), NULL);

    /* Insert the quit button into the
     * lower half of the form */

	gtk_container_add(GTK_CONTAINER(form), quit);
    gtk_form_constrain (GTK_FORM (form), quit, GTK_FORM_EDGE_TOP, GTK_FORM_ATTACH_WIDGET, button1, 0);
    gtk_form_constrain (GTK_FORM (form), quit, GTK_FORM_EDGE_LEFT, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), quit, GTK_FORM_EDGE_RIGHT, GTK_FORM_ATTACH_FORM, NULL, 0);
    gtk_form_constrain (GTK_FORM (form), quit, GTK_FORM_EDGE_BOTTOM, GTK_FORM_ATTACH_FORM, NULL, 0);

    gtk_widget_show (quit);
    gtk_widget_show (form);
    gtk_widget_show (window);

    gtk_main ();

    return 0;
}
