#ifndef __GTK_FORM_H__
#define __GTK_FORM_H__


#include <gdk/gdk.h>
#include <gtk/gtkcontainer.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GTK_TYPE_FORM			(gtk_form_get_type ())
#define GTK_FORM(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_FORM, GtkForm))
#define GTK_FORM_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_FORM, GtkFormClass))
#define GTK_IS_FORM(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_FORM))
#define GTK_IS_FORM_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_FORM))
#define GTK_FORM_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_FORM, GtkFormClass))

#define GTK_FORM_NULL_WIDGET		(0)


typedef struct _GtkForm  	  GtkForm;
typedef struct _GtkFormClass	  GtkFormClass;
typedef struct _GtkFormChild	  GtkFormChild;
typedef struct _GtkFormConstraint GtkFormConstraint;

typedef enum
{
  GTK_FORM_ATTACH_NONE,
  GTK_FORM_ATTACH_FORM,
  GTK_FORM_ATTACH_WIDGET,
  GTK_FORM_ATTACH_OPPOSITE_WIDGET,
  GTK_FORM_ATTACH_CENTER,
  GTK_FORM_ATTACH_SELF
} GtkFormAttachment;

typedef enum
{
/* N O T E:  These numbers ARE NOT ARBITRARY!! */
  GTK_FORM_EDGE_TOP = 0,
  GTK_FORM_EDGE_LEFT = 1,
  GTK_FORM_EDGE_BOTTOM = 2,
  GTK_FORM_EDGE_RIGHT = 3
} GtkFormEdge;

struct _GtkForm
{
  GtkContainer container;
  
  GList *children;
};

struct _GtkFormClass
{
  GtkContainerClass parent_class;
};

struct _GtkFormConstraint
{
  gint location;
  gint attachment;
  gint offset;
  gint factor;
  gint state;
  gboolean lower_container_relative;
  GtkFormChild *child;
  gfloat fraction;
};

struct _GtkFormChild
{
  GtkWidget *widget;
  GtkFormConstraint constraints [4];
};

GType	   gtk_form_get_type	      (void);
GtkWidget* gtk_form_new	      	      ();
void	   gtk_form_constrain	      (GtkForm	        *form,
				       GtkWidget        *child,
				       GtkFormEdge	 edge,
				       GtkFormAttachment attachment,
				       GtkWidget        *widget,
				       gint	 	 offset);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_FORM_H__ */
